<!DOCTYPE html>
<html>
<head>
    <style>
        body {
            margin: 0;
            font-family: Arial, sans-serif;
            /* padding-right: 220px; */
        }
        
        .right-nav {
            position: fixed;
            left: 0;
            top: 0;
            width: 200px;
            height: 100vh;
            background-color: #2c3e50;
            color: white;
            padding: 20px 10px;
            box-sizing: border-box;
            overflow-y: auto;
        }
        
        .right-nav h3 {
            margin-top: 0;
            color: white;
        }
        
        .right-nav ul {
            list-style: none;
            padding: 0;
        }
        
        .right-nav li {
            margin-bottom: 10px;
        }
        
        .right-nav a {
            text-decoration: none;
            color: #a4a4a4;
            display: block;
            padding: 5px;
            border-radius: 3px;
            transition: all 0.3s;
        }
        
        .right-nav a:hover, 
        .right-nav a.active {
            color: white;
            background-color: #3498db;
        }
        section {
            min-height: 300px;
            padding: 40px;
            border-bottom: 1px solid #eee;
        }

        button{
            width: 240px;
            height: 40px;
            margin-right: 6px;
        }
        .nav_language{
            font-size: 12px;
            display: flex;
            justify-content: end;
            height: 15px;
        }
        .nav_language a{
            padding: 0px;
            line-height: 15px;
        }
        .license-div{
            margin: 10px;
            display: flex;
            flex-direction: row;
            margin-bottom: 20px;
        }
        .div_margin{
            width: 20px;
        }
        .progress-wrapper {
            flex-grow: 1;
            height: 40px;
            text-align: center;
            display: flex;
            flex-direction: column;
            justify-content: center;
        }
        .progress-wrapper .progress {
            background-color: #74cb7a;
            width:0%;
            height: 20px;
        }
        .devce_info{
            width: 400px;
        }
        .devce_info div{
            margin-bottom: 10px;
        }
        .devce_info_item{
            width: 100%;
            display: flex;
        }
        .device_info_title{
            width: 100px;
            font-size: 16px;
            /* text-align: right;
            margin-right: 6px; */
        }
        .device_info_value{
            color: gray;
            white-space: nowrap;
        }

        .subtitle_line {
            width: 100%;
            display: inline-block;
            padding-bottom: 10px;
            background-image: linear-gradient(to right, #3498db, #9b59b6, #e74c3c);
            background-position: 0 100%;
            background-size: 100% 3px;
            background-repeat: no-repeat;
        }

        .table-rounded {
            border-collapse: separate;
            border-spacing: 0;
            width: 100%;
            margin: 25px 0;
            border-radius: 10px;
            overflow: hidden;
            box-shadow: 0 0 20px rgba(0, 0, 0, 0.1);
            font-family: 'Arial', sans-serif;
        }

        .table-rounded thead {
            background: linear-gradient(to right, #909398, #acc9a7);
            color: white;
        }

        .table-rounded th {
            padding: 15px;
            text-align: left;
            font-weight: 500;
            border-left: 1px solid #e0e0e0;
            border-right: 1px solid #e0e0e0;
            text-align: center;
        }

        .table-rounded td {
            padding: 12px 15px;
            border-bottom: 1px solid #e0e0e0;
            border-left: 1px solid #e0e0e0;
            border-right: 1px solid #e0e0e0;
            text-align: center;
        }

        .table-rounded tbody tr:last-child td {
            border-bottom: none;
        }

        .table-rounded tbody tr:nth-child(even) {
            background-color: #f9f9f9;
        }

        .table-rounded tbody tr:hover {
            background-color: #f1f1f1;
        }
        .ip-input-container {
          position: relative;
          display: flex;
          padding: 6px;
        }
        .ip-input-container div{
            padding: 4px;
            /* margin-right: 6px;
            margin-left: 6px; */
        }
        .ip-input-container button{
            padding: 4px;
            margin-left: 8px;
            height: unset;
            width: 100px;
        }
        .ip_format {
          padding: 4px;
          font-family: monospace;
          letter-spacing: 1px;
        }
        .gap{
            width: 4px;
        }
    </style>
</head>
<body>
    <div class="right-nav">
        <h3 id="id_title">配置管理</h3>
        <div class="nav_language">
            <a href="#" id="id_locales_zh" class="locales">中文版</a> 
            &nbsp;|&nbsp; 
            <a href="#" id="id_locales_en" class="locales">ENGLISH</a>
        </div>
        <ul>
            <li><a href="#section1" class="active" id="id_license_title">授权</a></li>
            <li><a href="#section2">PLC</a></li>
            <li><a href="#section3">GPIO</a></li>
            <li><a href="#section4" id="id_setting_title">设置</a></li>
        </ul>
    </div>
    <div style="margin-left: 200px;">
        <section id="section1">
            <h2 id="id_license_title2" class="subtitle_line">Codesys 授权管理</h2>
            <div>
                %if name == 'admin':
                <div class="license-div">
                    <button onclick="doCreate()" id="id_license_create"></button>
                    <div class="div_margin"></div>
                    <button onclick="doImport()" id="id_license_import"></button>
                    <input id="id_file_license" type="file" name="data" hidden/>
                    <div class="progress-wrapper">
                        <div id="progress-bar-license" class="progress"></div>
                    </div>
                </div>
                %end
                <div class="license-div">
                    <button onclick="doBackup()" id="id_license_backup"></button>
                    <div class="div_margin"></div>
                    <input id="id_file_upload" type="file" name="data" hidden/>
                    <button id="id_button_restore" onclick="doUpload()"></button>
                    <div class="progress-wrapper">
                        <div id="progress-bar-file1" class="progress"></div>
                    </div>
                </div>
            </div>
        </section>
        
        <section id="section2">
            <h2 id="id_plc_title" class="subtitle_line">Device Info</h2>
            <div>
                <div class="devce_info">
                    <div class="devce_info_item"><div class="device_info_title">Firmware:</div><div class="device_info_value" id="id_device_firmware"></div></div>
                    <div class="devce_info_item"><div class="device_info_title">Power:</div><div class="device_info_value" id="id_device_power"></div></div>
                    <button onclick="doDeviceFile()" id="id_deivce_file"></button>
                </div>
                <!-- <div class="div_margin"></div> -->
            </div>
        </section>
        
        <section id="section3">
            <h2 id="id_gpio_title" class="subtitle_line">扩展GPIO信息</h2>
            <div>
                <div class="gpio_info" id="id_table_gpio"></div>
            </div>
        </section>
        
        <section id="section4">
            <h2 id="id_setting_sub_title1" class="subtitle_line">设置</h2>
            <div>
                <div>
                    <div style="display: flex;">
                        <div id="id_setting_sub_title2" style="display: flex;">配置IP,</div>
                        <div id="id_setting_ip_msg" style="margin-left: 8px;color: chocolate;">说明</div>
                    </div>
                    <div id="id_setting_ip">
                        <!-- <div class="ip-input-container">
                            <div>eth0 &nbsp;> </div>
                            <div>IP:</div> 
                            <input type="text" class="ip_format" id="ip_ip_input" placeholder="000.000.000.000">
                            <div>Gateway:</div>
                            <input type="text" class="ip_format" id="ip_gw_input" placeholder="000.000.000.000">
                            <button>Apply</button>
                        </div> -->
                    </div>
                </div>
                <div></div>
            </div>
        </section>

    </div>
    <script>
        document.addEventListener('DOMContentLoaded', function() {
            const sections = document.querySelectorAll('section');
            const navLinks = document.querySelectorAll('.right-nav a');
            
            window.addEventListener('scroll', function() {
                let current = '';
                
                sections.forEach(section => {
                    const sectionTop = section.offsetTop;
                    const sectionHeight = section.clientHeight;
                    
                    if (pageYOffset >= (sectionTop - 100)) {
                        current = section.getAttribute('id');
                    }
                });
                
                navLinks.forEach(link => {
                    link.classList.remove('active');
                    if (link.getAttribute('href') === `#${current}`) {
                        link.classList.add('active');
                    }
                });
            });
        });

        function check_ip(e){
           // 自动添加点分隔符
          let value = this.value.replace(/[^0-9.]/g, '');
          let parts = value.split('.');
          
          // 限制每部分长度
          parts = parts.map(part => part.substring(0, 3));
          
          // 限制最多4部分
          if (parts.length > 4) {
            parts = parts.slice(0, 4);
          }
          
          // 重新组合
          this.value = parts.join('.');
        }

        let g_name = "{{ name }}"
        let g_info_str = "{{ info }}"
        let gpiochips_str = "{{ gpiochips }}"
        let nets_str = "{{ nets }}"
        // let g_info_str= "{ \"power\":\"255\", \"firmware\": \"hmi2120-070c\"}"
        g_info_str = g_info_str.replace(/&#039;/g,"\"")
        let g_info = JSON.parse(g_info_str)
        
        gpiochips_str = gpiochips_str.replace(/&#039;/g,"\"")
        let g_gpiochips = JSON.parse(gpiochips_str)
        
        nets_str = nets_str.replace(/&quot;/g,"\"")
        let g_nets = JSON.parse(nets_str)

        
        let locales={
            "zh": {
                "system-close": "关闭PLC配置管理",
                "system-close-warin": "关闭PLC配置管理后，该网页将无法访问",
                "title": "PLC配置管理",
                "license-title": "授权管理",
                "license-title2": "Codesys 授权管理",
                "license-create": "创建授权key",
                "license-create-warin": "该操作会覆盖已有文件\n请谨慎操作！",
                "license-import": "导入授权",
                "license-backup": "授权备份",
                "license-restore": "授权还原",
                "device-title": "设备信息",
                "device-file": "[下载] 设备描述文件",
                "device_file_err1": "没有找到文件",
                "gpio_title": "扩展GPIO信息",
                "setting": "设置",
                "setting_ip": "设置IP",
                "setting_ip_msg": "IP设置为0.0.0.0，将为自动切为动态获取IP"
            },
            "en": {
                "system-close": "Close PLC Setting",
                "system-close-warin": "After closing PLC Setting, this page will not work.",
                "title": "PLC Setting",
                "license-title": "License Management",
                "license-title2": "Codesys License Management",
                "license-create": "Create License Key",
                "license-create-warin": "This operation will overwrite the existing file!\nPlease operate with caution!",
                "license-import": "Import License",
                "license-backup": "Backup License",
                "license-restore": "Restore License",
                "device-title": "Device Info",
                "device-file": "[Download] Device Description File",
                "device_file_err1": "Not file found.",
                "gpio_title": "Expand GPIO",
                "setting": "Setting",
                "setting_ip": "Set IP",
                "setting_ip_msg": "Setting the IP address to 0.0.0.0 will switch it to dynamic IP allocation."
            }
        }
        let g_local = "en";
        let g_codesys_power = {
            "117": "ED-CODESYS-TV-SM-SC",
            "118": "ED-CODESYS-WV-SM-SC",
            "124": "ED-CODESYS-SM-CNC-SC",
            "126": "ED-CODESYS-WV-SM-CNC-SC",
            "127": "ED-CODESYS-TV-WV-SM-CNC-SC",
            "240": "ED-CODESYS-MC",
            "241": "ED-CODESYS-TV-MC",
            "242": "ED-CODESYS-WV-MC",
            "243": "ED-CODESYS-TV-WV-MC",
            "245": "ED-CODESYS-TV-SM-MC",
            "246": "ED-CODESYS-WV-SM-MC",
            "252": "ED-CODESYS-SM-CNC-MC",
            "254": "ED-CODESYS-WV-SM-CNC-MC",
            "255": "ED-CODESYS-TV-WV-SM-CNC-MC"
        }
        function switch_locales(){
            if (g_local in locales){
                let local = locales[g_local]
                document.getElementById("id_title").innerHTML = local["title"];
                document.getElementById("id_license_title").innerHTML = local["license-title"];
                document.getElementById("id_setting_title").innerHTML = local["setting"];
                document.getElementById("id_setting_sub_title1").innerHTML = local["setting"];
                document.getElementById("id_setting_sub_title2").innerHTML = local["setting_ip"];
                document.getElementById("id_setting_ip_msg").innerHTML = local["setting_ip_msg"];

                if(g_name == "admin"){
                    document.getElementById("id_license_create").innerHTML = local["license-create"];
                    document.getElementById("id_license_import").innerHTML = local["license-import"];
                }
                document.getElementById("id_license_title2").innerHTML = local["license-title2"];
                document.getElementById("id_license_backup").innerHTML = local["license-backup"];
                document.getElementById("id_button_restore").innerHTML = local["license-restore"];
                
                document.getElementById("id_plc_title").innerHTML = local["device-title"];
                document.getElementById("id_deivce_file").innerHTML = local["device-file"];
                // document.getElementById("id_server_switch_label").setAttribute("tip", local["system-close"]);

                document.getElementById("id_gpio_title").innerHTML = local["gpio_title"];
                
                // document.getElementById("id_setting_title").innerHTML = local["setting"];
            }
            
        }

        function init(){
            let elements = document.getElementsByClassName("locales");
            for (var i = 0; i < elements.length; i++) {
                elements[i].addEventListener('click', function(e){
                    if(this.id == "id_locales_zh"){
                        g_local = "zh";
                    }else{
                        g_local = "en";
                    }
                    switch_locales()
                });
            }
            switch_locales(g_local)

            if("firmware" in g_info){
                document.getElementById("id_device_firmware").innerHTML = g_info["firmware"].toUpperCase()
            }
            if("power" in g_info){
                if(g_info["power"] in g_codesys_power){
                    power_value = g_codesys_power[g_info["power"]] +"("+ g_info["power"]+")";
                }else{
                    power_value = g_info["power"];
                }
                document.getElementById("id_device_power").innerHTML = power_value
            }

            var t_upload = document.getElementById("id_file_upload");
            t_upload.onchange = function(){
                uploadFile('id_file_upload', 'progress-bar-file1', "EDA_pem_backup[_0-9]*.zip", '/upload');
            }
            if(g_name == "admin"){
                var t_license = document.getElementById("id_file_license");
                t_license.onchange = function(){
                    uploadFile('id_file_license', 'progress-bar-license', ".dat$", '/license');
                }
            }

            createTable();
            CreateIP();
        }

        function doClose(){
            if(!document.getElementById("id_server_switch").checked){
                var r=confirm(locales[g_local]["system-close-warin"]);
                if(r == false){
                    document.getElementById("id_server_switch").checked = true
                    return;
                }
                var request = new XMLHttpRequest();
                request.open('post', '/close');
                request.timeout = 45000;
                request.send();
            }
        }

        function uploadFile(id, id_bar, t_regexp, url){
            var formdata = new FormData();
            var upload_div = document.getElementById(id);
            if(upload_div.files.length == 0){
                return;
            }
            var patt=new RegExp(t_regexp);
            if(!patt.test(upload_div.files[0].name)){
                alert("The selected file does not meet the requirements.");
                return
            }
            formdata.append('data', upload_div.files[0]);

            var request = new XMLHttpRequest();

            request.upload.addEventListener('progress', function (e) {
                var file1Size = upload_div.files[0].size;

                if (e.loaded <= file1Size) {
                    var percent = Math.round(e.loaded / file1Size * 100);
                    document.getElementById(id_bar).style.width = percent + '%';
                    document.getElementById(id_bar).innerHTML = percent + '%';
                } 

                if(e.loaded == e.total){
                    document.getElementById(id_bar).style.width = '99%';
                    document.getElementById(id_bar).innerHTML = '99%';
                }
            });   
            request.open('post', url);
            request.timeout = 45000;
            request.send(formdata);
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    document.getElementById(id_bar).style.width = '100%';
                    document.getElementById(id_bar).innerHTML = '100%';
                }
            }
        }

        function doUpload(){
            document.getElementById("id_file_upload").click();
        }

        function doBackup(){
            var request = new XMLHttpRequest();
            request.open('post', '/backup');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == '-1' || request.responseText == -1){
                        alert("Backup failed!");
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        function doDownload(url){
            let t_div = document.createElement('a');
            t_div.setAttribute('href', url);
            let name = url.substring(url.lastIndexOf('/')+1)
            t_div.setAttribute('download', name);
            t_div.click();
        }

        function doCreate(){
            var r=confirm(locales[g_local]["license-create-warin"]);
            if(r == false){
                return;
            }
            var request = new XMLHttpRequest();
            request.open('post', '/create');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == '-1' || request.responseText == -1){
                        alert("eda-codesys not install.");
                    }else if(request.responseText == '-2' || request.responseText == -2){
                        alert("Create pem failed.");
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        function doImport(){
            document.getElementById("id_file_license").click();
        }

        function doDeviceFile(){
            var request = new XMLHttpRequest();
            request.open('post', '/device/file');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == 'device_file_err1'){
                        alert(locales[g_local]["device_file_err1"]);
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        function createTable() {
            const container = document.getElementById('id_table_gpio');
            const table = document.createElement('table');
            table.id = 'dynamicTable';
            table.className = 'table-rounded';
            
            // 创建表头
            const thead = document.createElement('thead');
            const headerRow = document.createElement('tr');
            
            ['GPIOCHIP', 'Lable', 'GPIO'].forEach(headerText => {
                const th = document.createElement('th');
                th.textContent = headerText;
                headerRow.appendChild(th);
            });
            
            thead.appendChild(headerRow);
            table.appendChild(thead);
            
            // 创建表体
            const tbody = document.createElement('tbody');
            let indexs = []
            for(let key1 in g_gpiochips){
                let index = 0
                for(let key2 in g_gpiochips[key1]){
                    const row = document.createElement('tr');

                    const td1 = document.createElement('td');
                    td1.textContent = "gpiochip" + key1;

                    const td2 = document.createElement('td');
                    td2.textContent = key2;

                    const td3 = document.createElement('td');
                    td3.textContent = g_gpiochips[key1][key2];

                    row.appendChild(td1);
                    row.appendChild(td2);
                    row.appendChild(td3);
                    tbody.appendChild(row);
                    index = index + 1;
                }
                indexs.push(index);
            }
            table.appendChild(tbody);
            let current = 1;
            for(let key in indexs){
                let index = indexs[key]
                if(index > 1){
                    let headerCell = table.rows[current].cells[0];
                    headerCell.rowSpan = index;
                    // headerCell.textContent = 
                    for(let i=1; i < index; i++){
                        table.rows[current+i].deleteCell(0);
                    }
                    current = current + index;
                }
            }
            container.appendChild(table);
        }

        function CreateIP(){
            let div=document.getElementById("id_setting_ip")
            for( let iface in g_nets){
                let net = g_nets[iface]
                if ("connected" in net){
                    if(net["connected"]){
                        let div_ip = document.createElement("div");
                        div_ip.setAttribute("class", "ip-input-container");
                        let method = " "
                        if ("auto" in net){
                            if (net["auto"]){
                                method = "auto"
                            }else{
                                method = "manual"
                            }
                        }
                        let newDiv = '<div>[</div><div style="width:60px;text-align: center;font-weight: bold;">'+ method +'</div><div>]</div>' + 
                            '<div>'+iface+' &nbsp;> </div>' + 
                            '<div class="gap"></div>'+
                            '<div>IP:</div>' +
                            '<input type="text" id="id_ip_' + iface + '" class="ip_format" value="' + net["ip"] + '" placeholder="000.000.000.000" va>' +
                            '<div class="gap"></div>'+
                            '<div>Gateway:</div>' +
                            '<input type="text" id="id_gw_' + iface + '" class="ip_format" value="' + net["gw"] + '" placeholder="000.000.000.000" va>' +
                            '<div class="gap"></div>'+
                            '<button onclick="setIP(\'' + iface + '\', \'' + net["connection"] + '\' )" type="button">Apply</button>' 
                        div_ip.innerHTML = newDiv
                        div.appendChild(div_ip)

                        document.getElementById('id_ip_'+iface).addEventListener('input', check_ip);
                        document.getElementById('id_gw_'+iface).addEventListener('input', check_ip);
                    }
                }
            }
        }

        function isValidIPv4(ip) {
            const regex = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
            return regex.test(ip);
        }

        function setIP(iface, connection){
            let ip = document.getElementById("id_ip_"+iface).value
            let gw = document.getElementById("id_gw_"+iface).value
            
            if(! isValidIPv4(ip)){
                alert("Invalid ip.")
                return
            }
            if(! isValidIPv4(gw)){
                alert("Invalid gw.")
                return
            }

            let data = {
                "connection": connection,
                "ip": ip,
                "gw": gw
            }

            var request = new XMLHttpRequest();
            request.open('POST', '/info/set/ip');
            request.timeout = 45000;
            request.setRequestHeader('Content-Type', 'application/json');
            request.send(JSON.stringify(data));
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == "1" || request.responseText == 1){
                        alert("Success")
                    }else{
                        alert("Failed")
                    }
                }
            }
        }

        init();
    </script>
</body>
</html>